﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=B4X_AziendaDigitaleDEMO.zip

Sub Class_Globals
	Private Root As B4XView
	Private Pane1 As B4XView
	Private xui As XUI
	
	Private TextCF As B4XView
	Private TextPwd As B4XView
	Private TextPIN As B4XView
	Private TextPIVA As B4XView
	
	Public FC As fecs
	Public ExternalID As Int = -1
	Public FileArchivio As String = "archivio.s3db"
	Private FileCredenziali As String = "cred.map"
	
	Private SD_LoadingIndicator1 As SD_LoadingIndicator
	
	Public MenuPage As PageMenu
	Public CercaArticoliPage As PageSearch
	Public AddArticoloPage As PageAddArticolo
	Public VediScontriniPage As PageVediScontrini
	Public Chiusure As PageChiusure
	Public CreaScontrino As PageCreaScontrino
	Public VisualizzazioneGenerica As PageVisualizzazioneGenerica
	Public FattureEmesse As PageFattureEmesse
	Public FattureRicevute As PageFattureRicevute

	Public KeyBoaardHeight As Int = 0
	
	#IF B4J
	Private SceltaIncarico As ComboBox
	#ELSE IF B4A
	Private SceltaIncarico As Spinner
	Public ScanBarCode As PageBarCodeReader
	#ELSE IF B4I
	Private SceltaIncarico As Picker
	Public ScanBarCode As PageBarCodeReader
	#End If
End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	
	MenuPage.Initialize
	B4XPages.AddPageAndCreate("Menu", MenuPage)
	CercaArticoliPage.Initialize
	B4XPages.AddPageAndCreate("CercaArticoli", CercaArticoliPage)
	AddArticoloPage.Initialize
	B4XPages.AddPageAndCreate("Articolo", AddArticoloPage)
	VediScontriniPage.Initialize
	B4XPages.AddPageAndCreate("VediScontrini", VediScontriniPage)
	Chiusure.Initialize
	B4XPages.AddPageAndCreate("Chiusure", Chiusure)
	CreaScontrino.Initialize
	B4XPages.AddPageAndCreate("CreaScontrino", CreaScontrino)
	VisualizzazioneGenerica.Initialize
	B4XPages.AddPageAndCreate("VisualizzazioneGenerica",VisualizzazioneGenerica)
	FattureEmesse.Initialize
	B4XPages.AddPageAndCreate("FattureEmesse",FattureEmesse)
	FattureRicevute.Initialize
	B4XPages.AddPageAndCreate("FattureRicevute",FattureRicevute)
	#IF B4A or B4I
	ScanBarCode.Initialize
	B4XPages.AddPageAndCreate("ScanBarCode",ScanBarCode)
	#END IF
	
	B4XPages.SetTitle(Me,"Azienda Digitale")
	FC.Initialize
	
	xui.SetDataFolder("fec")
	Log(xui.DefaultFolder)
	If File.Exists(xui.DefaultFolder,FileCredenziali) Then
		Dim M As Map= File.ReadMap(xui.DefaultFolder,FileCredenziali)
		TextCF.Text=M.Get("CF")
		TextPwd.Text=M.Get("Pwd")
		TextPIN.Text=M.Get("PIN")
		TextPIVA.Text=M.Get("PIVA")
	End If

	#IF B4J
	SceltaIncarico.Items.Clear
	SceltaIncarico.Items.AddAll(Regex.Split(",","Me Stesso,Tutore,Delega,Incarico,Intermediario"))
	SceltaIncarico.SelectedIndex=3
	#ELSE IF B4A
	SceltaIncarico.Clear
	SceltaIncarico.AddAll(Regex.Split(",","Me Stesso,Tutore,Delega,Incarico,Intermediario"))
	SceltaIncarico.SelectedIndex=3
	#ELSE IF B4I
	SceltaIncarico.SetItems(0,Regex.Split(",","Me Stesso,Tutore,Delega,Incarico,Intermediario"))
	SceltaIncarico.SelectRow(0,3,False)
	#End If

	#IF DEMO
	TextCF.Textcolor=xui.Color_Transparent
	TextPwd.Textcolor=xui.Color_Transparent
	TextPIN.Textcolor=xui.Color_Transparent
	TextPIVA.Textcolor=xui.Color_Transparent
	#End If
	
	PulisciCartellaAppoggio
End Sub

Private Sub B4XPage_Appear
	SD_LoadingIndicator1.Hide
End Sub

Private Sub B4XPage_KeyboardStateChanged (Height As Float)
	KeyBoaardHeight=Height
End Sub

#IF B4A 
Private Sub B4XPage_PermissionResult (Permission As String, Result As Boolean)
	ScanBarCode.B4XPage_PermissionResult (Permission, Result)
End Sub
#END IF


'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.
Private Sub ButtonAccedi_Click
	Dim M As Map = CreateMap("CF":TextCF.Text.Trim,"Pwd":TextPwd.Text.Trim,"PIN":TextPIN.Text.Trim,"PIVA":TextPIVA.Text.Trim)
	File.WriteMap(xui.DefaultFolder,FileCredenziali,M)
	
	SD_LoadingIndicator1.Show
	
	' NO ACCESS nel caso si voglia arrivare al menù senza accedere con le credenziali 
	' SI potrà usare solo il DATABASE articoli
	#IF not(NOACCESS)
	Wait For (FC.Connessione(TextCF.Text.Trim,TextPwd.Text.Trim,TextPIN.Text.Trim,TextPIVA.Text.Trim,Incarico)) complete (Success As Boolean)
	
	If FC.DenominazioneSociale="" Then 
		' ***** Se non ha restituito i dati aziendali
		' FC.SetDatiAziendali("Azienda","Indirizzo","CAP","Comune","Pr",TextCF.Text)
	End If
	#ELSE
		Dim Success As Boolean = True
	#END IF
	If Success Then
		B4XPages.ShowPageAndRemovePreviousPages("Menu")
	Else
		xui.MsgboxAsync("Credenziali non accettate o incarico errato","ERRORE")
	End If
	SD_LoadingIndicator1.Hide

End Sub

Private Sub PulisciCartellaAppoggio
	For Each F As String In File.ListFiles(xui.DefaultFolder)
		' elimina documenti.pdf, listafatture.json, fatture.xml
		If F.ToLowerCase.EndsWith(".pdf") Or F.ToLowerCase.EndsWith(".json") Or F.ToLowerCase.EndsWith(".xml") Or F.ToLowerCase.EndsWith(".p7m") Then
			File.Delete(xui.DefaultFolder,f)
		End If
	Next
	'File.Delete
End Sub

Private Sub Incarico As String
	Dim I As Int = 0
	Dim Res() As String = Regex.Split(",","meStessoAction,tutoreAction,delegaDirettaAction,incarichiAction,intermediarioAction")
	
	#If B4J
	I=SceltaIncarico.SelectedIndex
	#ELSE IF B4A
	I=SceltaIncarico.SelectedIndex
	#ELSE IF B4i
	I=SceltaIncarico.GetSelectedRow(0)
	#End If
	
	Return Res(I)
End Sub

#Region GlobalFunction

Public Sub RefreshArticoli
	B4XPages.MainPage.CercaArticoliPage.Refresh
End Sub

Public Sub ChiudiTastiera
	#IF B4A
		Dim K As Phone
		K.HideKeyboard(B4XPages.GetNativeParent(Me))
	#ELSE IF B4i
		B4XPages.GetNativeParent(Me).ResignFocus
	#ELSE IF B4J
		' Butta la tastiera dalla finestra
	#End If
End Sub

#End Region