﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.1
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	Private TextCodice As B4XView
	Private TextDescrizione As B4XView
	Private TextReparto As B4XView
	Private TextPrezzo As B4XView
	Private LabelIva As Label
	Private TextQuantita As B4XView
	Private TextGM As B4XView
	Private TextUM As B4XView
	Private TextNota As B4XView
	Private xSceltaIVA As xSceltaBox
	
	Private TpIva() As String
	Private VociIva() As String
	Private DB As SQL
	Private ID As Int
End Sub

'You can add more parameters here.
Public Sub Initialize As Object
	xui.SetDataFolder("fec")
	If File.Exists(xui.DefaultFolder,"archivio.s3db")=False Then File.Copy(File.DirAssets,"archivio.s3db",xui.DefaultFolder,B4XPages.MainPage.FileArchivio)

	TpIva=Regex.Split(",","4,5,10,22,N1,N2,N3,N4,N5,N6,N7")
	VociIva=Regex.Split(",","4%,5%,10%,22%,Operazioni escluse,Non soggette,Non imponibili,Esenti,Iva non esposta,Inversione contabile,Iva assolta in altro stato UE")
	Return Me
	
	' N1 - Operazioni escluse
	' N2 - Non soggette
	' N3 - Non imponibili
	' N4 - Esenti
	' N5 - Iva non esposta
	' N6 - Inversione contabile
	' N7 - Iva assolta in altro stato UE
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	'load the layout to Root
	Root.LoadLayout("Articolo")
	B4XPages.SetTitle(Me,"Articolo")
	
	xSceltaIVA.SetAll(TpIva)
End Sub

Private Sub B4XPage_Appear
	ID = B4XPages.MainPage.ExternalID
	If ID=-1 Then
		TextCodice.Text = ""
		TextDescrizione.Text = ""
		TextReparto.Text=""
		TextPrezzo.Text = "0.0"
		xSceltaIVA.SelectedIndex=TrovaIva("22")
		LabelIva.Text=VociIva(xSceltaIVA.SelectedIndex)
		
		TextQuantita.Text = "0.0"
		TextGM.Text = "0.0"
		TextUM.Text = ""
		TextNota.Text = ""
	Else
		DBInitialize
		Dim Rs As ResultSet = DB.ExecQuery("SELECT * FROM articoli WHERE ID=" & ID)
		If Rs.NextRow Then
			TextCodice.Text = Rs.GetString("Codice")
			TextDescrizione.Text = Rs.GetString("Descrizione")
			TextReparto.Text = Rs.GetString("Reparto")
			TextPrezzo.Text = Rs.GetString("Prezzo")
			TextQuantita.Text = Rs.GetString("Quantita")
			TextGM.Text = Rs.GetString("GiacenzaMinima")
			TextUM.Text = Rs.GetString("UM")
			TextNota.Text = Rs.GetString("Nota")
			xSceltaIVA.SelectedIndex=TrovaIva(Rs.GetString("IVA"))
			LabelIva.Text=VociIva(xSceltaIVA.SelectedIndex)
		End If
		DB.Close
	End If
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.
#IF B4A or B4I
Private Sub ButtonScan_Click
	B4XPages.ShowPage("ScanBarCode")
	B4XPages.MainPage.ScanBarCode.mCallBack=Me
End Sub
#END IF

Private Sub ButtonOk_Click
	If TextDescrizione.Text.Trim<>"" And TextPrezzo.Text.Trim<>"" And TextQuantita.Text.Trim<>"" Then
		Dim Iva As String=xSceltaIVA.SelectedItem
		
		DBInitialize
		If ID=-1 Then
			'nuovo			
			DB.ExecNonQuery2("INSERT INTO articoli (Codice,Descrizione,Reparto,Prezzo,IVA,Quantita,GiacenzaMinima,UM,Nota) VALUES (?,?,?,?,?,?,?,?)", _
			Array As Object(TextCodice.Text, TextDescrizione.Text.ToUpperCase,TextReparto.Text.ToUpperCase,TextPrezzo.Text,Iva,TextQuantita.Text,TextGM.Text,TextUM.Text,TextNota.Text))
			B4XPages.MainPage.RefreshArticoli
		Else
			'aggiorna
			DB.ExecNonQuery2("UPDATE articoli SET Codice=?, Descrizione=?, Reparto=?, Prezzo=?, IVA=?, Quantita=?, GiacenzaMinima=?, UM=?, Nota=? WHERE ID=" & ID, _
			Array As Object(TextCodice.Text, TextDescrizione.Text.ToUpperCase,TextReparto.Text.ToUpperCase,TextPrezzo.Text,Iva,TextQuantita.Text,TextGM.Text,TextUM.Text,TextNota.Text))
			B4XPages.MainPage.RefreshArticoli
		End If
		DB.Close
		
		B4XPages.ClosePage(Me)
	Else
		xui.MsgboxAsync("Campi non completi","ATTENZIONE")
	End If
End Sub

Private Sub ButtonAnnulla_Click
	B4XPages.ClosePage(Me)
End Sub

Private Sub ButtonDelete_Click
	If ID>-1 Then 
		' Cancella
		DBInitialize
		Wait For (xui.Msgbox2Async("Cancello?",TextDescrizione.Text,"Si","","No",Null)) Msgbox_Result (Result As Int)
		If Result = xui.DialogResponse_Positive Then
			DB.ExecNonQuery("DELETE FROM articoli WHERE ID=" & ID)
		End If
		DB.Close
	End If
	B4XPages.ClosePage(Me)
End Sub

Private Sub TextPrezzo_TextChanged (Old As String, New As String)
	If IsNumber(New)=False Then TextPrezzo.Text=Old
End Sub

Private Sub TextQuantita_TextChanged (Old As String, New As String)
	If IsNumber(New)=False Then TextQuantita.Text=Old
End Sub

Private Sub TextGM_TextChanged (Old As String, New As String)
	If IsNumber(New)=False Then TextGM.Text=Old
End Sub

Private Sub Flex_CellClick(Row As Int, Col As Int)
	
End Sub

Private Sub DBInitialize
	#IF B4J
		DB.InitializeSQLite(xui.DefaultFolder,B4XPages.MainPage.FileArchivio,False)
	#ELSE
		DB.Initialize(xui.DefaultFolder,B4XPages.MainPage.FileArchivio,False)
	#End If
End Sub

Private Sub Pane1_Touch (Action As Int, X As Float, Y As Float)
	B4XPages.MainPage.ChiudiTastiera
End Sub

Private Sub TrovaIva(Iva As String) As Int
	Dim R As Int = -1
	
	For I=0 To TpIva.Length-1
		Dim S As String = TpIva(I)
		
		If S=Iva Then R=i
	Next
	
	Return R
End Sub

Private Sub xSceltaIva_ValueChanged (Index As Int,Value As String)
	LabelIva.Text=VociIva(xSceltaIVA.SelectedIndex)
End Sub

Public Sub Camera_Return(msg As String)
	Sleep(600) ' serve a far apparire l'interfaccia
	TextCodice.Text=msg
End Sub