﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.1
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore
	
	Private ListArticoli As List
	
	Private FlexGrid1 As FlexGrid
	Private LabelTotale As B4XView
End Sub

'You can add more parameters here.
Public Sub Initialize As Object
	ListArticoli.Initialize
	Return Me
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	'load the layout to Root
	Root.LoadLayout("scontrino")
	B4XPages.SetTitle(Me,"Azienda Digitale - Scontrino")
	
	FlexGrid1.ColsName=Array As String("TS","","Descrizione","Qua","Prezzo","IVA","Totale","Omaggio")
	FlexGrid1.ColsWidth=Array As Int (0dip,80dip,200dip,100dip,100dip,100dip,100dip,100dip)
	FlexGrid1.ColsType=Array As Int(FlexGrid1.TypeString,FlexGrid1.TypeButton,FlexGrid1.TypeString,FlexGrid1.TypeString,FlexGrid1.TypeString,FlexGrid1.TypeList,FlexGrid1.TypeString,FlexGrid1.TypeString)
	FlexGrid1.SetColCustomize(1,xui.Color_DarkGray,xui.Color_White,xui.CreateFontAwesome(14))
End Sub

Private Sub B4Xpage_Appear
	LabelTotale.Tag="0"
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.

Private Sub ButtonAdd_Click
	B4XPages.ShowPage("CercaArticoli")
	B4XPages.MainPage.CercaArticoliPage.SelezionaArticoloPerScontrino(True)
End Sub

Private Sub ButtonNew_Click
	Dim TS As Long = DateTime.Now
	ListArticoli.Add(CreateMap("TS":-TS,"ID":"-1","Descrizione":"","Prezzo":"0.0","Iva":"22","Quantita": 1.0,"Omaggio":"N"))
	FlexGrid1.AddRow(Array As Object(-TS,Chr(0xF014),"",NumberFormat2("1.0",1,2,1,False),NumberFormat2("0.0",1,2,2,False),"4,5,10,22,N1,N2,N3,N4,N5,N6,N7",NumberFormat2("0.0",1,2,2,False),"N"),True)
	SelezionaIva(FlexGrid1.RowCount-1,"22")

End Sub

Private Sub ButtonClear_Click
	Wait For (xui.Msgbox2Async("Azzera lista?", "Svuota scontrino", "Si", "", "No", Null)) Msgbox_Result (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		ListArticoli.Clear
		FlexGrid1.ClearRows
		FlexGrid1.SetColCustomize(1,xui.Color_DarkGray,xui.Color_White,xui.CreateFontAwesome(14))
	End If
End Sub

Private Sub ButtonSend_Click
	If ListArticoli.Size>0 Then
		Wait For (xui.Msgbox2Async("Invio scontrino", "Invio AdE", "Si", "", "No", Null)) Msgbox_Result (Result As Int)
		If Result = xui.DialogResponse_Positive Then
			Dim fc As fecs = B4XPages.MainPage.FC
			Dim scontrino As documentoCommerciale
	
			scontrino.Initialize
			scontrino.datiDocumenti("","",DateTime.Now,False)
			scontrino.TipoPagamento=scontrino.PagamentoContanti
			
			For Each M As Map In ListArticoli
				Dim Omaggio As Boolean = ("S"=M.Get("Omaggio"))
				scontrino.AddElementoContabile2("",M.Get("Descrizione"),M.Get("Quantita"),M.Get("Prezzo"),M.Get("Iva"),Omaggio)
			Next
		
			fc.DocumentoCommerciale=scontrino
			wait for (fc.SendDocument) complete (Success As Boolean)
			If fc.EsitoInvioScontrino Then
				wait for (fc.DownloaddocumentoPDF(fc.Documento_ID)) Complete(Success As Boolean)
				Log(File.Combine("Scontrino pdf: " & xui.DefaultFolder ,fc.Documento_FileNamePDF))
				
				ScaricaMagazzino
				
				ListArticoli.Clear
				FlexGrid1.ClearRows
				FlexGrid1.SetColCustomize(1,xui.Color_DarkGray,xui.Color_White,xui.CreateFontAwesome(14))
				
				Dim sp As share_pdf
				sp.Initialize
				sp.Visualizza( xui.DefaultFolder,fc.Documento_FileNamePDF)
				
				B4XPages.ClosePage(Me)
			Else
				xui.MsgboxAsync("Scontrino NON INVIATO","ATTENZIONE")
			End If
		End If
	Else
		xui.MsgboxAsync("Scontrino VUOTO","Attenzione")
	End If

End Sub

Private Sub FlexGrid1_CellClick(Row As Int, Col As Int)
	If Col=7 Then ' OMAGGIO
		If "N"=FlexGrid1.GetCellValue(Row,7) Then FlexGrid1.SetCellValue(Row,7,"S") Else FlexGrid1.SetCellValue(Row,7,"N")
		FlexGrid1_Modified(Row, Col)
	else If Col=5 Then ' modifica iva
		
	else If Col=4 Then ' modifica prezzo
		FlexGrid1.EditCellOnSite(Row,Col)
	else If Col=3 Then ' modifica quantità
		FlexGrid1.EditCellOnSite(Row,Col)
	Else if Col=2 And FlexGrid1.GetCellValue(Row,0)<0 Then ' modifica descrizione se nuovo articolo
		FlexGrid1.EditCellOnSite(Row,Col)
	else if Col = 1 Then
		Wait For (xui.Msgbox2Async("Elimino rigo?", FlexGrid1.GetCellValue(Row,2), "Si", "", "No", Null)) Msgbox_Result (Result As Int)
		If Result = xui.DialogResponse_Positive Then
			Dim TS As Long = FlexGrid1.GetCellValue(Row,0)
			For i=0 To ListArticoli.Size-1
				Dim M As Map = ListArticoli.Get(i)
				If TS=M.Get("TS") Then
					ListArticoli.RemoveAt(i)
					FlexGrid1.RemoveRow(Row)
					Calcolo
					Exit
				End If
			Next
		End If
	End If
End Sub

Private Sub FlexGrid1_Modified(Row As Int, Col As Int)
	Dim TS As Long = FlexGrid1.GetCellValue(Row,0)
	For Each M As Map In ListArticoli
		If TS=M.Get("TS") Then
			Try
				Dim Omaggio As String = FlexGrid1.GetCellValue(Row,7)
				Dim Qua As Double = FlexGrid1.GetCellValue(Row,3)
				Dim Prezzo As Double = FlexGrid1.GetCellValue(Row,4)
				M.Put("Quantita",Qua)
				M.Put("Prezzo",Prezzo)
				M.Put("Omaggio",Omaggio)
				M.Put("Iva",FlexGrid1.GetCellValue(Row,5))
				FlexGrid1.SetCellValue(Row,3,NumberFormat2(Qua,1,2,1,False))
				FlexGrid1.SetCellValue(Row,6,NumberFormat2((Qua*Prezzo),1,3,2,False))

			Catch
				xui.MsgboxAsync("Errore nei dati","ATTENZIONE")
			End Try
			
			FlexGrid1.SetCellValue(Row,3,M.Get("Quantita"))
			FlexGrid1.SetCellValue(Row,4,M.Get("Prezzo"))
			Exit
		End If
	Next
				
	Calcolo
End Sub

Public Sub InsertArt(ID As String, Descrizione As String, Prezzo As Double, Iva As String)
	Dim TS As Long = DateTime.Now
	ListArticoli.Add(CreateMap("TS":TS,"ID":ID,"Descrizione":Descrizione,"Prezzo":Prezzo,"Iva":Iva,"Quantita": 1.0,"Omaggio":"N"))
	FlexGrid1.AddRow(Array As Object(TS,Chr(0xF014),Descrizione,NumberFormat2("1.0",1,2,1,False),NumberFormat2(Prezzo,1,2,2,False),"4,5,10,22,N1,N2,N3,N4,N5,N6,N7",NumberFormat2(Prezzo,1,2,2,False),"N"),True)
	SelezionaIva(FlexGrid1.RowCount-1,Iva)
	Calcolo
End Sub

Private Sub SelezionaIva(row As Int, Value As String)
	Dim L As List 
	L.Initialize
	l.AddAll(Regex.Split(",","4,5,10,22,N1,N2,N3,N4,N5,N6,N7"))
	Sleep(150)
	FlexGrid1.SetCellListIndex(row,5,L.IndexOf(Value))
End Sub

Private Sub Calcolo
	Dim Conto As Double = 0
	For Each M As Map In ListArticoli
	If "N"=M.Get("Omaggio") Then Conto=Conto + (M.Get("Prezzo") * M.Get("Quantita"))
	Next
	LabelTotale.Text=NumberFormat2(Conto,1,2,2,False)
	B4XPages.MainPage.ChiudiTastiera
End Sub

Private Sub ScaricaMagazzino
	Dim DB As SQL
	
	#IF B4J
		DB.InitializeSQLite(xui.DefaultFolder,B4XPages.MainPage.FileArchivio,False)
	#ELSE
		DB.Initialize(xui.DefaultFolder,B4XPages.MainPage.FileArchivio,False)
	#End If
	
	For Each M As Map In ListArticoli
		'scontrino.AddElementoContabile2("",M.Get("Descrizione"),M.Get("Quantita"),M.Get("Prezzo"),M.Get("Iva"),False)
		Dim Qua As Double = DB.ExecQuerySingleResult("SELECT Quantita FROM articoli WHERE ID=" & M.Get("ID"))
		Qua=Qua-M.Get("Quantita")
		DB.ExecNonQuery($"UPDATE articoli SET Quantita=$1.2{Qua} WHERE ID=${M.Get("ID")}"$)
	Next
	
	DB.Close
End Sub
