﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.1
@EndOfDesignText@
Sub Class_Globals
	Private Root As B4XView 'ignore
	Private xui As XUI 'ignore

	Private TextSearch As B4XView
	Private ButtonAdd As B4XView
	Private FlexGrid1 As FlexGrid	
	Private xReparto As xSceltaBox

	Private IndexReparto As Int = 0
	Private SelezionePerScontrino As Boolean = False
	Private Fields() As String 
	Private Order As Int = 2
	Private DB As SQL
End Sub

'You can add more parameters here.
Public Sub Initialize As Object
	xui.SetDataFolder("fec")
	If File.Exists(xui.DefaultFolder,"archivio.s3db")=False Then File.Copy(File.DirAssets,"archivio.s3db",xui.DefaultFolder,B4XPages.MainPage.FileArchivio)
	Fields = Regex.Split(",","ID,Codice,Descrizione,Prezzo,IVA,Quantita,GiacenzaMinima,UM,Nota")
	Return Me
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	'load the layout to Root
	Root.LoadLayout("articoli")
	B4XPages.SetTitle(Me,"Articoli - Ricerca")
	
	FlexGrid1.ColsName=Array As String("ID","Codice","Descrizione","Prezzo","iva","Qua","GM","UM","Nota")
	FlexGrid1.setColsAlignment(Array As String("CENTER","CENTER","LEFT","RIGHT","RIGHT","RIGHT","RIGHT","CENTER","LEFT"))
	FlexGrid1.setColsType(Array As Int(FlexGrid1.TypeInt,FlexGrid1.TypeString,FlexGrid1.TypeString,FlexGrid1.TypeString,FlexGrid1.TypeString,FlexGrid1.TypeString,FlexGrid1.TypeString,FlexGrid1.TypeString,FlexGrid1.TypeString))
	FlexGrid1.setColsWidth(Array As Int(0,130dip,Max(200dip,Root.Width-570dip),80dip,50dip,50dip,50dip,50dip,100dip))
End Sub

Private Sub B4XPage_Appear
	Refresh
End Sub

Private Sub B4XPage_Resize (Width As Int, Height As Int)
	FlexGrid1.setColsWidth(Array As Int(0,130dip,Max(200dip,Root.Width-570dip),80dip,50dip,80dip,80dip,50dip,100dip))
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.
Private Sub ButtonAdd_Click
	B4XPages.MainPage.ExternalID=-1
	B4XPages.ShowPage("Articolo")
End Sub

#IF B4A or B4I
Private Sub ButtonScan_Click
	B4XPages.ShowPage("ScanBarCode")
	B4XPages.MainPage.ScanBarCode.mCallBack=Me
End Sub
#END IF

Private Sub TextSearch_TextChanged (Old As String, New As String)
	Refresh
End Sub

Private Sub FlexGrid1_CellClick(Row As Int, Col As Int)
	If SelezionePerScontrino Then 
		' Seleziona articolo per scontrino
		DBInitialize
		Dim Rs As ResultSet = DB.ExecQuery("SELECT * FROM articoli WHERE ID=" & FlexGrid1.GetCellValue(Row,0))
		If Rs.NextRow Then
			TextSearch.Text=""
			B4XPages.MainPage.ChiudiTastiera
			B4XPages.MainPage.CreaScontrino.InsertArt(Rs.GetString("ID"),Rs.GetString("Descrizione"),Rs.GetString("Prezzo"),Rs.GetString("IVA"))
			B4XPages.ClosePage(Me)
		End If
		DB.Close
	Else
		' visualizzazione articolo
		B4XPages.MainPage.ExternalID=FlexGrid1.GetCellValue(Row,0)
		B4XPages.ShowPage("Articolo")
	End If
End Sub

Private Sub FlexGrid1_HeadClick(Index As Int)
	Order=Index
	Refresh
End Sub

Private Sub PopolaGriglia(Filtro As String)
	Dim QueryString As String
	Dim I As Int = 0
	FlexGrid1.ClearRows
	
	DBInitialize
	
	If Filtro.Trim="" Then ' Nessun filtro
		QueryString= "SELECT * FROM articoli ORDER BY " & Fields(Order)
		' filtro per reparto
		If IndexReparto>0 Then QueryString=QueryString.Replace("ORDER",$"WHERE Reparto="${xReparto.SelectedItem}" ORDER"$)
	Else ' Filtro per Descrizione o Codice
		QueryString=$"SELECT * FROM articoli WHERE Descrizione Like "%${Filtro.Trim.ToUpperCase}%" or Codice Like "%${Filtro.Trim.ToUpperCase}%" ORDER BY ${Fields(Order)}"$
		' filtro per reparto
		If IndexReparto>0 Then QueryString=QueryString.Replace("WHERE",$"WHERE Reparto="${xReparto.SelectedItem}" AND"$)
	End If
	
	Dim Rs As ResultSet = DB.ExecQuery(QueryString)
	If Rs.IsInitialized Then
		Do While Rs.NextRow And I<500
			FlexGrid1.AddRow(Array As Object(Rs.GetString("ID"),Rs.GetString("Codice"),Rs.GetString("Descrizione"),Rs.GetString("Prezzo"), _
			Rs.GetString("IVA"),Rs.GetString("Quantita"),Rs.GetString("GiacenzaMinima"),Rs.GetString("UM"),Rs.GetString("Nota")),False)
			I=I+1
		Loop
		FlexGrid1.Invalidate
	End If

	DB.Close
End Sub

Private Sub PopolaReparto
	Dim L As List
	DBInitialize
	
	xReparto.Clear
	L.Initialize
	L.Add("Tutti")
	Dim Rs As ResultSet = DB.ExecQuery("SELECT Reparto FROM articoli GROUP BY Reparto")
	If Rs.IsInitialized Then
		Do While Rs.NextRow
			L.Add(Rs.GetString("Reparto"))
		Loop
	End If
	xReparto.SetAll(L)
	xReparto.SelectedIndex=IndexReparto
	
	DB.Close
End Sub

Private Sub DBInitialize
	#IF B4J
		DB.InitializeSQLite(xui.DefaultFolder,B4XPages.MainPage.FileArchivio,False)
	#ELSE
		DB.Initialize(xui.DefaultFolder,B4XPages.MainPage.FileArchivio,False)
	#End If
End Sub

Public Sub Refresh
	PopolaGriglia(TextSearch.Text)
	PopolaReparto
End Sub

Public Sub SelezionaArticoloPerScontrino(Sel As Boolean )
	SelezionePerScontrino=Sel
	ButtonAdd.Visible=Not(Sel)
End Sub

Private Sub xReparto_ValueChanged (Index As Int, Value As String)
	IndexReparto=Index
	PopolaGriglia(TextSearch.Text)
End Sub

Public Sub Camera_Return(msg As String)
	Sleep(600) ' serve a far apparire l'interfaccia
	TextSearch.Text=msg
	If xui.IsB4i Then Refresh
End Sub